﻿using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAServiceResultInstances
    {
        [NotNull]
        static public UAServiceResult Instance0 => new UAServiceResult();

        [NotNull]
        static public UAServiceResult Instance1 => new UAServiceResult
        {
            AdditionalInfo = "testAdditionalInfo1",
            Description = "testDescription1",
            StatusCode = UAStatusCode.FromUASeverity(UASeverity.BadOrFailure)
        };

        [NotNull]
        static public UAServiceResult Instance2 => new UAServiceResult
        {
            AdditionalInfo = "testAdditionalInfo2",
            Description = "testDescription2",
            InnerResult = Instance1,
            QualifiedSymbolicId = new UAQualifiedName("testUri2", "testName2"),
            StatusCode = UAStatusCode.FromUASeverity(UASeverity.BadOrFailure)
        };
    }
}
