﻿using System;
using System.ComponentModel;
using System.Drawing.Design;
using System.Windows.Forms;
using OpcLabs.BaseLib.Forms.Common;
using OpcLabs.BaseLib.Forms.Design;
using OpcLabs.BaseLib.Forms.Extensions;

namespace OpcLabs.BaseLibFormsTestApp
{
    public partial class TimeSpanInputTestForm : Form
    {
        public TimeSpanInputTestForm()
        {
            InitializeComponent();
            propertyGrid1.SelectedObject = _testClass;

            timeSpanInput1.BeginInit();
            timeSpanInput1.MinValue = 1;
            timeSpanInput1.MaxValue = Int32.MaxValue;
            timeSpanInput1.LastUnitDecimalPlaces = 0;
            timeSpanInput1.AllowDisabling = true;
            timeSpanInput1.DisabledValue = -1;
            timeSpanInput1.Int32Value = -1;
            timeSpanInput1.EndInit();


            //timeSpanInput1.MinValue = 3;
            //timeSpanInput1.MaxValue = 1000;
            //timeSpanInput1.DisabledValue = -1;
            ////timeSpanInput1.DoubleValue = -1;
            //timeSpanInput1.Int32Value = -1;

//            toolTip2.ShowToolTipOverChildControlsFor(timeSpanInput1);
            toolTip2.ShowToolTipOverChildControlsFor(this);
        }

        private readonly TestClass _testClass = new TestClass();

        public class TestClass
        {
            [EditorAttribute(typeof(MillisecondsDoubleEditor), typeof(UITypeEditor))]
            public Double TimeSpan1 { get; set; }
            [EditorAttribute(typeof(MillisecondsDoubleEditor), typeof(UITypeEditor))]
            [MillisecondsEditorParameters(TimeUnitCombination.DaysHoursMinutesSecondsMilliseconds, TimeUnits.All, 0.0, 100000000.0, 3, -1.0)]
            public Double TimeSpanDisabling { get; set; }
            [EditorAttribute(typeof(MillisecondsDoubleEditor), typeof(UITypeEditor))]
            [MillisecondsEditorParameters(TimeUnitCombination.DaysHoursMinutesSecondsMilliseconds, TimeUnits.None, 0.0, 10000.0, 3)]
            public Double TimeSpanUpDown { get; set; }
            [EditorAttribute(typeof(MillisecondsDoubleEditor), typeof(UITypeEditor))]
            [MillisecondsEditorParameters(upDownsToDisplay: TimeUnitCombination.Milliseconds, textBoxesToDisplay: TimeUnits.None, minValue: 0.0, maxValue: 10000.0, lastUnitDecimalPlaces: 3, disabledValue: -1.0)]
            public Double TimeSpanUpDownMs { get; set; }
            [EditorAttribute(typeof(MillisecondsDoubleEditor), typeof(UITypeEditor))]
            [MillisecondsEditorParameters(TimeUnitCombination.None, TimeUnits.Seconds, 0.0, 10000.0, 0, (double)(-1))]
            public Double TimeSpanText { get; set; }
            [EditorAttribute(typeof(MillisecondsInt32Editor), typeof(UITypeEditor))]
            [MillisecondsEditorParameters(upDownsToDisplay: TimeUnitCombination.Milliseconds, textBoxesToDisplay: TimeUnits.None, minValue: 0.0, maxValue: 10000.0, lastUnitDecimalPlaces: 0, disabledValue: -1.0)]
            public Int32 TimeSpanUpDownInt32 { get; set; }
            [EditorAttribute(typeof(NonZeroMillisecondsInt32Editor), typeof(UITypeEditor))]
            public Int32 TimeSpanNonZeroInt32 { get; set; }

            [EditorAttribute(typeof(NonZeroMillisecondsDoubleEditor), typeof(UITypeEditor))]
            public Double TimeSpanNonZeroDouble { get; set; }

        }


    }
}
