﻿
using JetBrains.Annotations;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    partial class EasyDAClientTestBase
    {
        protected void WriteItemValueCatalogTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor,
            [NotNull] DAItemCatalogEntry itemCatalogEntry)
        {
            WriteItemValueTest_Basic(serverDescriptor, itemCatalogEntry.Element);
        }



        private void WriteItemValueTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor,
            [NotNull] DAItemDescriptor itemDescriptor)
        {
            TestSection.Arrange();
            AssertUtilities.WriteLine(serverDescriptor);
            AssertUtilities.WriteLine(itemDescriptor);
            AssertUtilities.WriteLine("");

            TestEnvironment.PrecheckServer(serverDescriptor);
            var client = new EasyDAClient();
            
            object value = client.ReadItemValue(serverDescriptor, itemDescriptor);
            AssertUtilities.WriteLine(value);

            TestSection.Act();
            client.WriteItemValue(serverDescriptor, itemDescriptor, value);

            TestSection.Assert();

            // IMPROVE: have test where the values changes
        }
    }
}
