﻿using System;
using System.Diagnostics;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Connectivity.Point;
using OpcLabs.BaseLib.Data;
using OpcLabs.BaseLib.Extensions;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Connectivity;
using OpcLabs.EasyOpc.DataAccess.Connectivity.Internal;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess.Connectivity
{
    public class DAConnectivityTest
    {

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void CreateReaderAndReadItemPointTest()
        {
            var connectivity = new DAConnectivity();
            // ReSharper disable once PossibleNullReferenceException
            var pointReader = (DAPointReader)connectivity.GetService<IReadPointService>().CreateReader();
            Assert.IsNotNull(pointReader);
            Assert.IsFalse(pointReader.IsFrozen);

            var itemPoint = new DAItemPoint("OPCLabs.KitServer.2", "Demo.Ramp");
            var parameters = new DAItemPointReadParameters();
            var arguments = new DAItemPointReadArguments();
            pointReader.Read(itemPoint, parameters, arguments);
            Debug.WriteLine(arguments.Exception);
            Assert.IsNull(arguments.Exception);
            Assert.AreEqual("", arguments.ErrorId);
            Assert.AreEqual("", arguments.ErrorMessage);
            Assert.AreEqual(StatusInfo.Normal, arguments.StatusInfo);
            Assert.AreEqual((DAQuality)DAQualities.GoodNonspecific, arguments.Quality);
            object value = arguments.Value;
            Debug.WriteLine(value);
            Assert.IsNotNull(value);
            Assert.IsInstanceOfType(value, typeof(Double));
        }
    }
}
