﻿// $Header: SimulationNode.cs 20120904 10:23 AM zbynekz $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

using System;
using System.Diagnostics.CodeAnalysis;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Annotations;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer
{
    [CLSCompliant(false)]
    [Designable(false)]
    [SuppressMessage("OpcLabs.VSI", "CX5213:ExpandableObjectConverterImpliesDesignable")]
#pragma warning disable 3021
    public class SimulationNode : DAMappedNode
#pragma warning restore 3021
    {
        // ReSharper disable InconsistentNaming

        public SimulationNode()
        {
            RegisterSet_1 = new RegisterSetNode();
        }

        [CanBeNull]
        [DANode]
        [SuppressMessage("Microsoft.Naming", "CA1707:IdentifiersShouldNotContainUnderscores")]
        public RegisterSetNode RegisterSet_1 { get; set; }

        [DANode(BrowsePath = "Incrementing (1 s)"), DAItem]
        public virtual Int32 IncrementingValue { get; set; }

        [DANode, DAItem]
        [SuppressMessage("Microsoft.Naming", "CA1707:IdentifiersShouldNotContainUnderscores")]
        public virtual Int32 Register_I4 { get; set; }
        
        // ReSharper restore InconsistentNaming
    }
}
