﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Net.Sockets;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy
{
    [TestClass]
    public class WcfServiceTest
    {
        [ClassInitialize]
        static public void SocketPrecheck(TestContext context)
        {
            if (!TcpClientUtilities.CanCreate("localhost", 13667))
                Assert.Inconclusive("Failed pre-check: Socket exception.");
        }

        // ReSharper disable InconsistentNaming

        [Ignore]    // IMPROVE: put it back
        [TestCategory("Live")]
        [TestMethod]
        public void ReadItemValueTest()
        {
            var client = new DAClientClient();

            object value = client.ReadItemValue("", LegacyTestDefs.ProgIds.KitServer, LegacyTestDefs.DataAccess.ItemIds.Constant_I4);

            Assert.IsNotNull(value);
            Assert.AreEqual(typeof(Int32), value.GetType());
            // IMPROVE: test the value itself
        }

        [Ignore]    // IMPROVE: put it back
        [TestCategory("Live")]
        [TestMethod]
        public void ReadItemValueTest_Repeated()
        {
            const int loopCount = 1000;
            for (int i = 0; i < loopCount; i++)
            {
                AssertUtilities.WriteLine(i);
                ReadItemValueTest();
            }
        }

        // ReSharper restore InconsistentNaming
    }
}
