﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace
{
    public partial class AESubconditionElementTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AESubconditionElement CreateSerializationTarget0()
        {
            return new AESubconditionElement();
        }

        [NotNull]
        public AESubconditionElement CreateSerializationTarget1()
        {
            return new AESubconditionElement
            {
                Definition = "TestDefinition1",
                Description = "TestDescription1",
                Name = "TestName1",
                Severity = 441
            };
        }

        [NotNull]
        public AESubconditionElement CreateSerializationTarget2()
        {
            return new AESubconditionElement
            {
                Definition = "TestDefinition2",
                Description = "TestDescription2",
                Name = "TestName2",
                Severity = 442
            };
        }

        [NotNull]
        public AESubconditionElement CreateSerializationTarget3()
        {
            return new AESubconditionElement
            {
                Definition = "TestDefinition3",
                Description = "TestDescription3",
                Name = "TestName3",
                Severity = 443
            };
        }
    }
}
