﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Generic.Extensions;
using OpcLabs.BaseLibFactory.OperationModel;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Extensions;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.DataAccess
{
    public class DAPropertyValueDictionaryTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public DAPropertyValueDictionary CreateSerializationTarget0()
        {
            return new DAPropertyValueDictionary();
        }

        [NotNull]
        public DAPropertyValueDictionary CreateSerializationTarget1()
        {
            var propertyValues = new DAPropertyValueDictionary();
            propertyValues.AddNew(DAPropertyIds.None, ValueResultInstances.Instance2);
            propertyValues.AddNew(DAPropertyIds.Value, ValueResultInstances.Instance2);
            propertyValues.AddNew(11111, ValueResultInstances.Instance2);
            propertyValues.AddNew(22222, ValueResultInstances.Instance2);
            propertyValues.AddNew(33333, ValueResultInstances.Instance2);
            propertyValues.AddNew(44444, ValueResultInstances.Instance2);
            propertyValues.AddNew(55555, ValueResultInstances.Instance2);
            return propertyValues;
        }
    }
}
