﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class RealTimeAutomation_RoyaltyFreeAnsiCOpcUaServerStackToolkitAndSdk_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Utopia.rta.local:RealTimeAutomation:UA:SampleServer ;ns=1;i=400",
            "nsu=http://opcfoundation.org/UA/ ;i=2258"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://Utopia:48015" };

        public override string Password => "password";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test07_CreateAndUseMultipleSessions),
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group001_Session_Test11_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group005_InformationModel_Test01_Browse_StandardFolders),
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:Utopia.rta.local:RealTimeAutomation:UA:SampleServer ;ns=1;i=12" };

        public override string UserName => "user1";
    }
}
