﻿
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class SoftingIndustrialAutomation_DataFeesOpcSis_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[]
        {
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Arrays/Byte"
        };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[]
        {
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Arrays/Double"
        };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Dynamic/All Profiles/Scalar/Float",
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Dynamic/All Profiles/Scalar/Double"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://10.10.101.195:4810/SoftingDataFEEDSIS" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test09_CreateSession_Https_None),   // HTTPS endpoint not provided
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),   // cert not provided
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group013_Discovery_Test04_GetEndpoints_Server)
        });

        public override string Password => "pass";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Scalar/Int16",
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Scalar/Int64"
        };

        public override string UserName => "User1";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[]
        {
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Scalar/Float",
            "nsu=dotNetDemo.http://opcfoundation.org/Quickstarts/ReferenceApplications ;ns=16;s=/Static/All Profiles/Scalar/Byte"
        };
    }
}
